;**************************************************************
;***    EMS5B5.ASM                                          ***
;***                                                        ***
;***    function        EMS_Ems.allocDMARegs40(             ***
;***                        var regSet:     Byte)           ***
;***                        : Boolean;                      ***
;***                                                        ***
;***    Allocates DMA register set                          ***
;***                                                        ***
;***    Returns 0 if no error or an error code.             ***
;***                                                        ***
;***                                                        ***
;***                                                        ***
;***    (Ems Version 4.0)                                   ***
;**************************************************************

        .model  large,pascal   

        include emsdefs.asm 

        extrn   errno:WORD  

;
;   Define entry point
;
        public  EMS_Ems@allocDMARegs40

        .code

EMS_Ems@allocDMARegs40 proc regSet:Far Ptr Word, self:DWord

        mov     ax,AllocDMARegs40       ; Make the EMS call
        int     Ems           

        or      ah,ah                   ; Set flags
        jnz     error

        mov     al,bl                   ; Register set #
        xor     ah,ah                   ; zero extend to word
        les     bx,regSet               ; Return it
        mov     es:[bx],ax

        xor     ax,ax                   ; Return OK
        ret         

error:
        mov     al,ah                   ; AL gets error code
        xor     ah,ah                   ; Zero extend
        mov     errno,ax                ; Save in errno too
        ret

EMS_Ems@allocDMARegs40 endp             ; End of procedure

        end                             ; End of source file
